#==============================================================================#
#                        Copyright 2021-2024 ArchaicSoft                       #
#                                                                              #
# Boost Software License - Version 1.0 - August 17th, 2003                     #
#                                                                              #
# Permission is hereby granted, free of charge, to any person or organization  #
# obtaining a copy of the software and accompanying documentation covered by   #
# this license (the "Software") to use, reproduce, display, distribute,        #
# execute, and transmit the Software, and to prepare derivative works of the   #
# Software, and to permit third-parties to whom the Software is furnished to   #
# do so, all subject to the following:                                         #
#                                                                              #
# The copyright notices in the Software and this entire statement, including   #
# the above license grant, this restriction and the following disclaimer,      #
# must be included in all copies of the Software, in whole or in part, and     #
# all derivative works of the Software, unless such copies or derivative       #
# works are solely in the form of machine-executable object code generated by  #
# a source language processor.                                                 #
#                                                                              #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   #
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     #
# FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT    #
# SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE    #
# FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,  #
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER  #
# DEALINGS IN THE SOFTWARE.                                                    #
#==============================================================================#

extends Node

const ADDON_PATH  : String = "res://addons/asfw/splash_screen/"
const RUN_PATH    : String = "application/run/"
const SPLASH_PATH : String = "application/boot_splash/"

@onready var img  : TextureRect = $Image
@onready var mask : ColorRect   = $Mask

var fade_count  : float = 0.0
var fade_frames : int   = 0
var fade_stage  : int   = 0
var pause       : bool  = false

func _ready():
	self.color  = ProjectSettings.get_setting(SPLASH_PATH + "bg_color", Color.WHITE)
	mask.color  = ProjectSettings.get_setting(SPLASH_PATH + "fg_color", Color.BLACK)
	fade_frames = ProjectSettings.get_setting(SPLASH_PATH + "fade_speed", 100)
	img.texture = load(ProjectSettings.get_setting(SPLASH_PATH + "image", ADDON_PATH + "splash.svg"))

func _physics_process(delta):
	if pause: return
	else: check_skip()
	
	match(fade_stage):
		0:
			mask.color.a = 1 - fade_count / fade_frames
			if fade_count >= fade_frames:
				fade_stage += 1
				fade_count = -1
		
		1:
			if fade_count >= fade_frames:
				fade_stage += 1
				fade_count = -1
		
		2:
			mask.color.a = fade_count / fade_frames
			if fade_count >= fade_frames:
				pause = true
				
				var scene: String = ProjectSettings.get_setting(RUN_PATH + "start_scene")
				if scene != "": get_tree().change_scene_to_file(scene)
	
	fade_count += 1

func check_skip() -> void:
	if Input.is_action_just_pressed("ui_accept") or \
	   Input.is_action_just_pressed("ui_cancel"):
		fade_stage = 2
		fade_frames = 50
